/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package br.com.client;

import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.RootPanel;
import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.i18n.client.LocaleInfo;
import com.google.gwt.user.client.ui.DialogBox;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.HasHorizontalAlignment;
import com.google.gwt.user.client.ui.ListBox;
import com.google.gwt.user.client.ui.TextBox;
import com.google.gwt.user.client.ui.VerticalPanel;

/**
 * Main entry point.
 *
 * @author otavio
 */
public class exemploEntryPoint implements EntryPoint {

    private Label label;
    private Button modificarTexto;
    private Button button;
    private Button adicionarValores;
    private Button abrirJanela;
    private ListBox comboBox;
    private DialogBox dialogBox;
    private TextBox normalText;
    private boolean visivel = true;

    /**
     * Creates a new instance of exemploEntryPoint
     */
    public exemploEntryPoint() {
    }

    /** 
     * The entry point method, called automatically by loading a module
     * that declares an implementing class as an entry-point
     */
    public void onModuleLoad() {
        initForm();

        adicionarValores.addClickHandler(new ClickHandler() {

            public void onClick(ClickEvent event) {
                if (!normalText.getValue().equals("") && !normalText.getValue().equals(null)) {
                    String texto;
                    texto = normalText.getValue();
                    comboBox.addItem(texto);
                    normalText.setValue("");
                }

            }
        });
        modificarTexto.addClickHandler(new ClickHandler() {

            public void onClick(ClickEvent event) {
                if (!normalText.getValue().equals("") && !normalText.getValue().equals(null)) {
                    String texto;
                    texto = normalText.getValue();
                    label.setText(texto);

                    normalText.setValue("");
                }

            }
        });
        button.addClickHandler(new ClickHandler() {

            public void onClick(ClickEvent event) {
                visivel = !visivel;
                label.setVisible(visivel);
                comboBox.setVisible(visivel);
                normalText.setVisible(visivel);
                adicionarValores.setVisible(visivel);
                modificarTexto.setVisible(visivel);
                abrirJanela.setVisible(visivel);

                if (visivel) {
                    
                    button.setHTML("Ocultar Componentes");
                } else {
                    button.setText("Mostrar Componentes");
                }
            }
        });





        abrirJanela = new Button("Dialogo",
                new ClickHandler() {

                    public void onClick(ClickEvent sender) {
                        dialogBox = createDialogBox();
                        dialogBox.center();
                        dialogBox.show();
                    }
                });

        RootPanel.get().add(button);
        RootPanel.get().add(abrirJanela);
        RootPanel.get().add(label);
        RootPanel.get().add(comboBox);
        RootPanel.get().add(normalText);
        RootPanel.get().add(adicionarValores);
        RootPanel.get().add(modificarTexto);

    }

    private void initForm() {

        normalText = new TextBox();
        label = new Label("Exemplo GWT");
        button = new Button("Ocultar Componentes");
        modificarTexto = new Button("Modificar o texto");
        adicionarValores = new Button("Adicionar na Lista");
        dialogBox = createDialogBox();
        comboBox = new ListBox();

    }

    private DialogBox createDialogBox() {


        final DialogBox dialogBox = new DialogBox();
        dialogBox.ensureDebugId("cwDialogBox");
        dialogBox.setText("Texto exemplo do GWT  ");

        VerticalPanel dialogContents = new VerticalPanel();
        dialogContents.setSpacing(4);
        dialogBox.setWidget(dialogContents);

        HTML details = new HTML("Este é um exemplo básico do uso do gwt<br> "
                + "Com recursos html dentre outros <br>"
                + "Estejam a vontade a partir daqui iniciar seus projetos<br>"
                + "<font color='blue'>Todos os recursos de html</font> </font>"
                + "<font color='green'>podem ser inseridos</font>"
                + "<h1>Java</h1>");
        dialogContents.add(details);
        dialogContents.setCellHorizontalAlignment(details,
                HasHorizontalAlignment.ALIGN_CENTER);

        Button closeButton = new Button("Fechar",
                new ClickHandler() {

                    public void onClick(ClickEvent event) {
                        dialogBox.hide();
                    }
                });
        dialogContents.add(closeButton);

        if (LocaleInfo.getCurrentLocale().isRTL()) {
            dialogContents.setCellHorizontalAlignment(closeButton,
                    HasHorizontalAlignment.ALIGN_LEFT);

        } else {
            dialogContents.setCellHorizontalAlignment(closeButton,
                    HasHorizontalAlignment.ALIGN_RIGHT);
        }


        return dialogBox;
    }
}
